Index: res/res_musiconhold.c
===================================================================
--- res/res_musiconhold.c	(revision 282046)
+++ res/res_musiconhold.c	(working copy)
@@ -1081,7 +1081,20 @@
 	return 0;
 }
 
+static void moh_rescan_files(void) {
+	struct ao2_iterator i;
+	struct mohclass *c;
 
+	i = ao2_iterator_init(mohclasses, 0);
+
+	while ( (c = ao2_iterator_next(&i)) ) {
+		moh_scan_files(c);
+		ao2_ref(c, -1);
+	}
+
+	ao2_iterator_destroy(&i);
+}
+
 static int moh_diff(struct mohclass *old, struct mohclass *new)
 {
 	if (!old || !new) {
@@ -1584,6 +1597,9 @@
 			ao2_t_callback(mohclasses, OBJ_NODATA, moh_class_mark, NULL, "Mark deleted classes");
 			ao2_t_callback(mohclasses, OBJ_UNLINK | OBJ_NODATA | OBJ_MULTIPLE, moh_classes_delete_marked, NULL, "Purge marked classes");
 		}
+		if (cfg == CONFIG_STATUS_FILEUNCHANGED) {
+			moh_rescan_files();
+		}
 		return 0;
 	}
 
